<?php

namespace Drupal\my_auth\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

class MyAuthForm extends ConfigFormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'my_auth_form';
  }

/**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {

    $form = parent::buildForm($form, $form_state);

  	$config = $this->config('my_auth.settings');

	$form['page_text'] = array(
      '#type' => 'textarea',
      '#title' => $this->t('Contenu texte de la page My Auth'),
      '#default_value' => $config->get('my_auth.page_text'),
      '#description' => $this->t('Permet de définir le texte de ma page'),
    );
	$form['page_redirect'] = array(
      '#type' => 'textfield',
      '#title' => $this->t('lieu de redirection'),
      '#default_value' => $config->get('my_auth.page_redirect'),
      '#description' => $this->t('Permet de définir ...'),
    );

	return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function validateForm(array &$form, FormStateInterface $form_state) {

  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {

    $config = $this->config('my_auth.settings');

    $config->set('my_auth.page_text', $form_state->getValue('page_text'));
    $config->set('my_auth.page_redirect', $form_state->getValue('page_redirect'));
    
    $config->save();

    return parent::submitForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    return [
      'my_auth.settings',
    ];
  }

}
